import random
import copy

class mind:
    def __init__(self):
        pass

    def init(self, glob, count):
        self.test = count
        self.possible = []
        tmp = [-1]*count
        self.recure(glob,count,tmp)

    def recure(self,g,c,x):
        if(c>0):
            for i in range(0,g):
                x[c-1] =i
                self.recure(g,c-1,x)
        else:
            self.possible.append(copy.copy(x))

    def guess(self):
        tmp = [self.possible[i] for i in range(len(self.possible)) if self.possible[i]!=-1]
        try:
            ans = tmp[random.randint(0,len(tmp)-1)]
        except Exception:
            ans =None
        return ans
        
    def eval(self, g,b,w):
        for i in range(len(self.possible)):
            if(self.possible[i]!=-1):
                bp,wp = self.evaluate(self.possible[i],g)
                if([bp,wp]!=[b,w]):
                    self.possible[i] = -1
    def evaluate(self, g, t):
        white = 0
        black = 0
        mask=[]
        for i in range(self.test):
           if (g[i]==t[i]):
               black+=1
               mask.append(1)
           else:
               mask.append(0)
        for i in range(self.test):
            if (g[i]!=t[i]):
                for j in range(self.test):
                    if (mask[j]==0 and g[i]==t[j]):
                        white+=1
                        mask[j]=1
                        break
        return black, white

if __name__ =="__main__":
    init = [int(x) for x in input().split()]
    mymind = mind()
    mymind.init(init[1],init[0])
    guess = mymind.guess()
    print(" ".join([str(i) for i in guess]))
    answer = [int(x) for x in input().split()]
    if(len(answer)!=2):
            print("ERROR")
    else:
        while(answer != [0,init[0]]):
            mymind.eval(guess,answer[1],answer[0])
            guess = mymind.guess()
            if(guess is None):
                print("ERROR")
                break
            print(" ".join([str(i) for i in guess]))
            answer = [int(x) for x in input().split()]
            if(len(answer)!=2):
                print("ERROR")
                break